// "Chips Tester Device"
//     Library file
//    (C) S.A., 1997
//---------------------------------------------------------------------
#include "chiptest.h"
#include <all.h>
#include <math.h>
//---------------------------------------------------------------------
/*
	   p      PC DB25
IN BITS
	   Data In     Acknowlege           Port 379h bit 6

OUT BITS
	   P/S In Reg  D7                   Port 378h
	   Sync Din    D6
	   /Power On   D5
	   Sync Dout   D4
	   Data Out    D3
	   Reg Write   D2
	   Reserved    D1
		       D0
*/
//=====================================================================
byte Installok = 0;       // 1 - ᮥ, 0 - , -1 -  .
word Portwrite = 0x378;   // p 室 p
word Portread  = 0x379;   // p 室 p
byte Outbuf = 0;          // p . p
byte Bdatain   = 0x40;
byte Bpsinreg  = 0x80;
byte Bsyncdin  = 0x40;
byte iBpoweron = 0x20;   // p
byte Bsyncdout = 0x10;
byte Bdataout  = 0x8;
byte Bregwrite = 0x4;
byte Breserved = 0x2;
//=====================================================================
void standby(void)
{
double q = sin(sin(1303));
}
//=====================================================================
void clearport(void)
{
bset(iBpoweron);
bclr(Bdatain | Bpsinreg | Bsyncdin | Bsyncdout | Bdataout | Bregwrite);
post();
}
//=====================================================================
void bon(byte bits)
{
bset(bits);
post();
}
//=====================================================================
void boff(byte bits)
{
bclr(bits);
post();
}
//=====================================================================
void bset(byte bits)
{
Outbuf |= bits;
}
//=====================================================================
void bclr(byte bits)
{
Outbuf &= ~bits;
}
//=====================================================================
void post(void)
{
outportb(Portwrite, Outbuf);
standby();
}
//=====================================================================
byte treadbit(void)
{
byte r = (inportb(Portread) & Bdatain) ? 1 : 0;
standby();
return r;
}
//=====================================================================
int found(word adrout, word adrin)
{
Portwrite = adrout;
Portread = adrin;
clearport();
tester_on();
word r0 = msoi(0x0000);
word r1 = msoi(0x3FFF);
tester_off();
if (r0 < 0x3FFF && r1 > 0)
 return 1;
return 0;
}
//=====================================================================
int find(void)
{
for (word q = 0; q < 30; q ++)
 {
 if (found(0x378, 0x379) || found(0x278, 0x279) || found(0x3BC, 0x3BD))
  return 1;
 delay(1);
 }
return 0;
}
//=====================================================================
byte tester_test(word loops)
{
disable();
for (int q = 0; q < 3; q ++)
 {
 tester_off();
 tester_on();
 }
for (word l = 0; l < loops; l ++)
 for (word a = 0; a < 14; a ++)
  if (msoi(1 << a) != 1 << a)
   {
   tester_off();
   sound(400); delay(300); nosound();
   return 0;
   }
tester_off();
sound(600); delay(100); sound(800); delay(100); nosound();
return 1;
}
//=====================================================================
byte testerinstall(word lptportnum)
{
if (! find())
 {
 Portwrite = 0;
 Portread = 0;
 sound(300); delay(300); nosound();
 Installok = 0;
 return 0;
 }
Installok = 1;
sound(850); delay(100); sound(650); delay(100); nosound();
clearport();
tester_test(5);
return 1;
}
//=====================================================================
void ingate(void)
{
boff(Bsyncdin);
bon(Bpsinreg);
bon(Bsyncdin);
boff(Bsyncdin);
}
//=====================================================================
void outgate(void)
{
boff(Bregwrite);
bon(Bregwrite);
boff(Bregwrite);
}
//=====================================================================
word msread(void)
{
word v = 0;
boff(Bpsinreg);
for (int a = 0; a < 14; a ++)
 {
 v <<= 1;
 v |= treadbit();
 bon(Bsyncdin);
 boff(Bsyncdin);
 }
return v;
}
//=====================================================================
void mswrite(word v)
{
v <<= 2;
boff(Bsyncdout);
for (int a = 0; a < 14; a ++)
 {
 if (v & 0x8000)
  bon(Bdataout);
 else
  boff(Bdataout);
 v <<= 1;
 bon(Bsyncdout);
 boff(Bsyncdout);
 }
}
//=====================================================================
word msin(void)
{
if (Portread == 0 && Portwrite == 0)
 return 0;
disable();
ingate();
word b = msread();
enable();
return b;
}
//=====================================================================
void msout(word v)
{
if (Portread == 0 && Portwrite == 0)
 return;
disable();
mswrite(v);
outgate();
enable();
}
//=====================================================================
word msoi(word v)
{
msout(v);
return msin();
}
//=====================================================================
void tester_on(void)
{
if (Portread == 0 && Portwrite == 0)
 return;
boff(iBpoweron);
delay(100);
}
//=====================================================================
void tester_off(void)
{
if (Portread == 0 && Portwrite == 0)
 return;
bon(iBpoweron);
delay(100);
}
//=====================================================================
